;;; $Id: tpmacros.scm,v 1.2 1996/09/19 13:05:37 queinnec Exp $

;;; Exercises on macros

(defmacro ifn (condition alors sinon)
  `(if ,condition ,sinon ,alors) )

(defmacro ifn2 (condition alors . sinon)
  (if (pair? sinon)
      `(if ,condition (begin . ,sinon) ,alors) 
      `(if (not ,condition) ,alors) ) )

(defmacro yf (condition alors sinon)
  `(let ((condition ,condition)
         (alors (lambda () ,alors))
         (sinon (lambda () ,sinon)) )
     (if condition 
         (condition (alors))
         (sinon) ) ) )

;;; end of tpmacros.scm
